import { LanguageService } from '@angular/language-service';
import { IConnection, TextDocumentSyncKind, TextDocumentIdentifier, Position } from 'vscode-languageserver';
export declare function fileNameToUri(fileName: string): string;
export interface NgServiceInfo {
    fileName?: string;
    languageId?: string;
    service?: LanguageService;
    offset?: number;
}
export interface TextDocumentEvent {
    kind: 'context' | 'opened' | 'closed' | 'change';
    document: TextDocumentIdentifier;
}
export interface TextDocumentLine {
    text: string;
    line: number;
    start: number;
}
export declare class TextDocuments {
    private event?;
    private projectService;
    private logger;
    private host;
    private languageIds;
    private changeNumber;
    constructor(event?: (event: TextDocumentEvent) => void);
    readonly syncKind: TextDocumentSyncKind;
    listen(connection: IConnection): void;
    offsetsToPositions(document: TextDocumentIdentifier, offsets: number[]): Position[];
    getDocumentLine(document: TextDocumentIdentifier, offset: number): TextDocumentLine;
    getNgService(document: TextDocumentIdentifier): LanguageService | undefined;
    getServiceInfo(document: TextDocumentIdentifier, position?: Position): NgServiceInfo;
    ifUnchanged(f: () => void): () => void;
    private logErrors;
    private handleProjectEvent;
}
