import * as ts from 'typescript/lib/tsserverlibrary';
/**
 * Create a logger instance to write to file.
 * @param options Logging options.
 */
export declare function createLogger(options: Map<string, string>): Logger;
export declare class Logger implements ts.server.Logger {
    private readonly logFilename;
    private readonly traceToConsole;
    private readonly level;
    private fd;
    private seq;
    private inGroup;
    private firstInGroup;
    constructor(logFilename: string, traceToConsole: boolean, level: ts.server.LogLevel);
    static padStringRight(str: string, padding: string): string;
    close(): void;
    getLogFileName(): string;
    perftrc(s: string): void;
    info(s: string): void;
    err(s: string): void;
    startGroup(): void;
    endGroup(): void;
    loggingEnabled(): boolean;
    hasLevel(level: ts.server.LogLevel): boolean;
    msg(s: string, type?: ts.server.Msg): void;
    private readonly canWrite;
    private write;
}
